export declare interface CanvasStyleOptions {
    strokeStyle?: string;
    lineWidth?: number;
    fillStyle?: string;
}

export declare interface DetPostConfig {
    shape: number;
    thresh: number;
    box_thresh: number;
    unclip_ratio: number;
}

export declare interface DrawBoxOptions {
    canvas?: HTMLCanvasElement;
    style?: CanvasStyleOptions;
}

export declare function init(detCustomModel?: string, recCustomModel?: string): Promise<void>;

/**
 * 文本识别
 * @param {HTMLImageElement} image 原图
 * @param {Object} options 绘制文本框配置参数
 * @param detConfig 识别相关可调参数
 */
export declare function recognize(image: HTMLImageElement, options?: DrawBoxOptions, detConfig?: DetPostConfig): Promise<{
    text: string[];
    points: any;
}>;

export { }
